//DYNB000I JOB DYNB,'DYNBLOAD1',CLASS=A,REGION=7096K,                   00000010
//            MSGCLASS=A,MSGLEVEL=(1,1),NOTIFY=HERC01 
//*                                                                     00000020
//*   INSTALL THE DYNBLOAD SUBROUTINE with PGM RC                       00000030
//*                                                                     00000040
//*                                                                     00003330
//*  NOW ASSEMBLE AND LINK THE DYNBLOAD ROUTINE                         00003340
//*                                                                     00003350
//STEP4 EXEC ASMFCL,PARM.ASM='OBJ,NODECK'                               00003360
//ASM.SYSIN DD *                                                        00003370
*                                                                     * 00000010
         PRINT ON,GEN,NODATA                                            00000020
*---------------------------------------------------------------------* 00000030
*                                                                     * 00000040
* THIS ROUTINE IS DESIGNED TO PROVIDE DYNAMIC PROGRAM LOADING         * 00000050
* FOR PROGRAMS COMPILED WITH COMPILERS THAT ONLY SUPPORT STATIC       * 00000060
* CALLS.  MVT COBOL IS AN EXAMPLE OF THIS.                            * 00000070
*                                                                     * 00000080
* EXAMPLE:   IN MVT COBOL,                                            * 00000090
*      CALL 'PROGRAMA' USING PARM-1 PARM-2.                           * 00000100
* IT IS NECESSARY TO LINK THE OBJECT MODULE FOR THE PROGRAMA          * 00000110
* ROUTINE TO EACH CALLING COBOL PROGRAM.  THE PROGRAM CODE AND        * 00000120
* WORKING STORAGE ARE PRESERVED BETWEEN CALLS.                        * 00000130
*                                                                     * 00000140
* IN MVS COBOL, THE STATIC CALL WILL FUNCTION THE SAME WAY.  AN       * 00000150
* EXTENSTION TO COBOL ALLOWS FOR DYNAMIC CALLS TO SUBROUTINES.        * 00000160
*                                                                     * 00000170
*     WORKING-STORAGE SECTION.                                        * 00000180
*     ...                                                             * 00000190
*         05  WS-PGM-NAME        PIC X(8)  VALUE SPACES.              * 00000200
*     ...                                                             * 00000210
*      ...                                                            * 00000220
*      PROCEDURE DIVISION.                                            * 00000230
*      ...                                                            * 00000240
*      MOVE 'PROGRAMA' TO WS-PGM-NAME.                                * 00000250
*      CALL WS-PGM-NAME USING PARM-1 PARM-2.                          * 00000260
*                                                                     * 00000270
* THIS CALL RESULTS IN 'PROGRAMA' BEING LOADED AT RUN TIME INTO       * 00000280
* MEMORY AND THEN CALLED.   EACH TIME A MODULE IS DYNAMICALLY CALLED, * 00000290
* MVS CHECKS TO SEE IF THE LOAD MODULE IS RENTRANT OR RESUABLE.  IF   * 00000300
* SO, THE COPY OF THE PROGRAM IN MEMORY IS REUSED.  IF NOT, A NEW     * 00000310
* COPY IF THE PROGRAM IS LOADED FROM DISK AND CALLED.                 * 00000320
*                                                                     * 00000330
* THE MVS COBOL DYNAMIC CALL CAN BE SIMULATED IN MVT COBOL BY         * 00000340
* CALLING AN ASSEMBLER PROGRAM WHICH WILL LOAD THE SUBROUTINE AND     * 00000350
* PASS THE OPTIONAL PARAMETERS.                                       * 00000360
*                                                                     * 00000370
* EXAMPLE:                                                            * 00000380
*     WORKING-STORAGE SECTION.                                        * 00000390
*     01  WS-PGM-BLK.                                                 * 00000400
*         05  WS-PGM-NAME        PIC X(8)  VALUE SPACES.              * 00000410
*         05  WS-PGM-ADDR        PIC X(4)  VALUE LOW-VALUES.          * 00000420
*         05  WS-CALL-MODE       PIC X     VALUE 'K'.                 * 00000430
*         05  FILLER             PIC X(3)  VALUE LOW-VALUES.          * 00000440
*         05  WS-PGM-RC          PIC S9(9) COMP  VALUE +0.            * LB201403
*      ...                                                            * 00000450
*      PROCEDURE DIVISION.                                            * 00000460
*      ...                                                            * 00000470
*                                                                     * 00000480
*      MOVE 'PROGRAMA' TO WS-PGM-NAME.                                * 00000490
*      CALL 'DYNBLOAD' USING WS-PGM-BLK  PARM-1 PARM-2.               * LB201403
*                                                                     * 00000510
*                                                                     * 00000520
*  NOTES:                                                             * 00000530
*    - THE WS-PGM-ADDR FIELD MUST BE INITIALIZED TO LOW-VALUES        * 00000540
*      BEFORE THE FIRST CALL.  DO NOT CHANGE THE VALUE OF             * 00000550
*      THIS FIELD.  IF IT IS NOT LOW-VALUES, DYNBLOAD ASSUMES         * LB201403
*      THIS IS THE ADDRESS IN MEMORY OF PROGRAMA.                     * 00000570
*                                                                     * 00000580
*    - THE WS-CALL-MODE  MUST BE 'K' OR 'R'.                          * 00000590
*        K INDICATES KEEP THE WORKING STORAGE AND MODULE FROM         * 00000600
*          LAST CALL.  IF WS-PGM-ADDR IS NOT LOW-VALUES, THIS         * 00000610
*          ADDRESS IS CALLED.                                         * 00000620
*                                                                     * 00000630
*        R INDICATE REFRESH MODULE FROM DISK, THUS CLEARING           * 00000640
*          WORKING STORAGE BACK TO THE INITIAL VALUES.                * 00000650
*                                                                     * 00000660
*       YOU MAY DEFINE AND USE AS MANY WS-PGM-BLK AS NEEDED.          * 00000670
*                                                                     * 00000680
* IT IS NECESSARY TO LINK THE OBJECT MODULE FOR THE DYNBLOAD          * LB201403
* ROUTINE TO EACH CALLING PROGRAM. IT IS ALSO NECESSARY TO LINK       * 00000700
* THE PROGRAMA AS AN EXECUTABLE MODULE.  THE BENEFIT OF THIS IS THE   * 00000710
* MODULE IS NOT STATIC LINKED INTO ALL MODULES WHICH CALL IT.         * 00000720
* IF THE ROUTINE IS CHANGED, AS LONG AS THE PARM FORMATS ARE          * 00000730
* THE SAME, THE CALLING MODULES WILL NOT NEED TO BE CHANGED.          * 00000740
*                                                                     * 00000750
* FOR EXAMPLE, AN MVT COBOL APPLICATION CONSISTS OF 100 PROGRAMS,     * 00000760
* EACH OF WHICH CALL AN IO MODULE CALLED IOMOD.  USING STATIC CALLS,  * 00000770
* A COPY OF IOMOD IS LINK EDITED INTO EACH OF THE 100 LOAD MODULES.   * 00000780
* MAKING A CHANGE TO IOMOD WOULD REQUIRE 100 LOAD MODULES TO BE       * 00000790
* RELINKED.  USING DYNBLOAD, ONLY IOMOD WOULD NEED TO BE RELINKED.    * LB201403
* THE 100 CALLING MODULES WOULD ONLY NEED TO BE TESTED.               * 00000810
*                                                                     * 00000820
* I HAVE USED THIS ROUTINE SINCE THE 1970'S.  IT WILL WORK WITH       * 00000830
* MVS COBOL BUT IT COULD CONFUSE DEBUGGERS.                           * 00000840
*                                                                     * 00000850
* THIS CODE IS PLACED IN THE PUBLIC DOMAIN AND MAY BE FREELY USED     * 00000860
* AND INCORPORATED INTO DERIVED WORKS AS LONG AS ATTRIBUTION TO THE   * 00000870
* ORIGINAL AUTHORSHIP REMAINS IN ANY DISTRIBUTED COPIES OF THE ALC    * 00000880
* SOURCE.                                                             * 00000890
*                                                                     * 00000900
* REWRITTEN DECEMBER, 2006 BY ED LISS                                 * 00000910
* HTTP://WWW.SUMMERMOON.COM/HERCULES/                                 * 00000920
*                                                                     * 00000930
* MODIFIED MARCH 2014 BY LARRY BELMONTES (LB201403)                   * LB201403
* HTTPS://WWW.SHAREABITOFIT.NET/DYNBLOAD-IN-MVS38J/                   * LB201403
*   - CREATED COPY OF DYNALOAD TO MAINTAIN ORIGINAL PROGRAM           * LB201403
*   - PASS RETURN CODE FROM CALLED PROGRAM (FROM R15) TO              * LB201403
*     INVOKING PROGRAM VIA DYNBLOAD COMM AREA                         * LB201403
*---------------------------------------------------------------------* 00000940
         EJECT                                                          00000950
*                                                                       00000960
         LCLC  &SYSECT                                                  00000970
&SYSECT  SETC  'DYNBLOAD'          ROUTINE IDENTIFICATION               LB201403
*                                                                       00000990
&SYSECT  CSECT                                                          00001000
*                                                                       00001010
@IDENT01 B     @IDENT04(R15)       BRANCH AROUND IDENT CONSTANTS        00001020
         DC    AL1(@IDENT03-@IDENT02)                                   00001030
@IDENT02 DC    C'&SYSECT V1'                                            00001040
         DC    C'&SYSDATE &SYSTIME - '                                  00001050
         DC    C'DYNAMIC LOAD ROUTINE FOR MVT COBOL'                    00001060
@IDENT03 DS    0H                                                       00001070
@IDENT04 EQU   *-@IDENT01                                               00001080
*                                                                       00001090
         SAVE  (14,12)                                                  00001100
*                                                                       00001110
         BALR  R12,0               BASE REGISTERS ARE 12                00001120
         USING *,R12                                                    00001130
*                                                                       00001140
         LR    R5,R13              COPY CALLER'S SAVEAREA ADDR          00001150
         LA    R13,SAVEAREA        ESTABLISH MY SAVEAREA                00001160
         ST    R5,4(,R13)          BACK CHAIN SAVE AREAS                00001170
         ST    R13,8(,R5)          FORWARD CHAIN SAVE AREAS             00001180
*                                                                       00001190
*---------------------------------------------------------------------* 00001200
* AT LEAST ONE PARM MUST BE PASSED.  THIS IS THE NAME OF THE LOAD     * 00001210
* MODULE TO DYNAMICALY CALL.  IF THIS IS MISSING, THE MODULE WILL     * 00001220
* ABORT WITH A U0001 ABEND CODE.                                      * 00001230
* THIS MODULE WILL STRIP OFF THE PROGRAM NAME AND PASS THE REMAINING  * 00001240
* PARMS, IF ANY, TO THE SUBROUTINE BEING CALLED.                      * 00001250
* IF THERE ARE NO PARMS TO PASS, R1 IS SET TO ZEROS.                  * 00001260
*---------------------------------------------------------------------* 00001270
         LTR   R1,R1                                                    00001280
         BNZ   PARMFND             BRANCH IF PARM LIST PRESENT          00001290
         ABEND 1,,,USER                                                 00001300
PARMFND  DS    0H                                                       00001310
         LR    R2,R1               COPY PARMLIST ADDR TO R2             00001320
         L     R3,0(,R2)           GET ADDR OF PROGRAM NAME             00001330
         MVC   PGMBLK,0(R3)        GET PGMBLK - NAME, ADDR, FUNC        00001340
         TM    0(R2),X'80'         CHECK FOR LAST PARM                  00001350
         BZ    OPTPARMS            MORE PARMS FOUND                     00001360
         SR    R4,R4               SET PARM ADDR TO ZERO                00001370
         B     DYNACALL                                                 00001380
OPTPARMS DS    0H                                                       00001390
         LA    R4,4(,R2)           ADVANCE TO NEXT PARM                 00001400
DYNACALL DS    0H                                                       00001410
         L     R0,PGMADDR          GET ADDR IN MEMORY                   00001420
         CLC   PGMADDR,=4X'00'     IS IS ZEROS                          00001430
         BE    DOLOAD                                                   00001440
         CLI   PGMFUNC,C'K'        KEEP CALL?                           00001450
         BE    SKIPLOAD                                                 00001460
         CLI   PGMFUNC,C'R'                                             00001470
         BE    DOLOAD                                                   00001480
         ABEND 2,,,USER            ABORT IF NO CORRECT PARM             00001490
*                                                                       00001500
DOLOAD   DS    0H                                                       00001510
         LOAD  EPLOC=PGM                                                00001520
         ST    R0,PGMADDR                                               00001530
SKIPLOAD DS    0H                                                       00001540
         MVC   0(L'PGMBLK,R3),PGMBLK PUT CTL BLK BACK IN CALLERS WS     00001550
         LR    R1,R4               PUT PARMLIST IN R1                   00001560
         LR    R15,R0              COPY MODULE ADDR TO R15              00001570
         BALR  R14,R15             CALL LOADED PGM                      00001580
         ST    R15,PGMRC           SAVE R15 AS RC                       LB201403
         MVC   16(L'PGMRC,R3),PGMRC  PUT RC      BACK IN CALLERS WS     LB201403
GOBACK   DS    0H                                                       00001590
*---------------------------------------------------------------------* 00001600
* RETURN TO CALLING PROGRAM WITH ZERO RETURN CODE IN R15              * 00001610
*---------------------------------------------------------------------* 00001620
         L     R13,4(,R13)    RESET TO CALLERS SAVE AREA                00001630
         RETURN (14,12),RC=0                                            00001640
*                                                                       00001650
         DS    0F                                                       00001660
PGMBLK   DS    0CL20           INCREASE COMM AREA BY 4 BYTES            LB201403
PGM      DC    CL8' '                                                   00001680
PGMADDR  DC    F'0'                                                     00001690
PGMFUNC  DC    C' '                                                     00001700
         DS    CL3                                                      00001710
PGMRC    DS    F               CALLED PROGRAM RC                        LB201403
*                                                                       00001720
*---------------------------------------------------------------------* 00001730
* MY REGISTER SAVE AREA                                               * 00001740
*---------------------------------------------------------------------* 00001750
SAVEAREA DS    18F                                                      00001760
*                                                                       00001770
R0       EQU   0                                                        00001780
R1       EQU   1                                                        00001790
R2       EQU   2                                                        00001800
R3       EQU   3                                                        00001810
R4       EQU   4                                                        00001820
R5       EQU   5                                                        00001830
R6       EQU   6                                                        00001840
R7       EQU   7                                                        00001850
R8       EQU   8                                                        00001860
R9       EQU   9                                                        00001870
R10      EQU   10                                                       00001880
R11      EQU   11                                                       00001890
R12      EQU   12                                                       00001900
R13      EQU   13                                                       00001910
R14      EQU   14                                                       00001920
R15      EQU   15                                                       00001930
*                                                                       00001940
         END                                                            00001950
//LKED.SYSLMOD DD DSN=your.pds.loadlib(DYNBLOAD),   <-- TARGET          00003380
//         DISP=SHR                                                     00003390
